<script setup lang="ts">
import { type ComputedRef, reactive, computed, type Ref, ref } from 'vue'
import type { Places, PlacesParams, Row, Seat, Session, TicketParams } from '@/utils/types'
import { useTicketsStore } from '@/stores/tickets'
import { stringToArray } from '@/utils/helpers'
import { useVuelidate } from '@vuelidate/core'
import { required } from '@vuelidate/validators'
import { useMovieStore } from '@/stores/movie'

const props = defineProps<{
  id: string
}>()

const emit = defineEmits([
  'close'
])

const loading: Ref<boolean> = ref(false)

const formData = reactive<{
  daytime: null | string
  showdate: null | string
  row: null | number
  seat: null | number
}>({
  daytime: null,
  showdate: null,
  row: null,
  seat: null
})

const formRules = {
  daytime: {required},
  showdate: {required},
  row: {required},
  seat: {required}
}

const v$ = useVuelidate(formRules, formData)

const movieStore = useMovieStore()
const ticketsStore = useTicketsStore()

const sessions: ComputedRef<Session[] | null> = computed(() => movieStore.sessions)
const sessionsDates: ComputedRef<string[] | null> = computed(() => sessions.value ? sessions.value.map(session => session.showdate) : null)
const sessionsTimes: ComputedRef<string[] | null> = computed(() => {
  if (sessions.value && formData.showdate) {
    const session = sessions.value.find(session => session.showdate === formData.showdate)

    if (session && session.daytime) {
      return stringToArray(session.daytime, ';')
    }
  }

  return null
})

const places: ComputedRef<Places | null> = computed(() => movieStore.places)
const placesRows: ComputedRef<Row[] | null> = computed(() => places.value ? places.value.map(place => place[0]) : null)
const placesSeat: ComputedRef<Seat[] | null> = computed(() => {
  if (places.value && formData.row) {
    const placeRow = places.value.find(place => place[0].row === formData.row)

    if (placeRow && placeRow[1]) {
      return placeRow[1].filter(seat => seat.is_free)
    }
  }
  return null
})

const onSelectTrigger = async (): Promise<void> => {
  if (formData.daytime && formData.showdate) {
    const params: PlacesParams = {
      movie_id: props.id,
      daytime: formData.daytime,
      showdate: formData.showdate
    }

    await movieStore.getSessionPlaces(params)

    formData.row = null
    formData.seat = null
  }
}

const onSubmitButtonClick = async (): Promise<void> => {
  loading.value = true

  const body: TicketParams = {movie_id: props.id, ...formData}
  await ticketsStore.createTicket(body)

  emit('close')
  loading.value = false
}

const onCancelButtonClick = (): void => {
  emit('close')
}
</script>

<template>
  <v-card-text>
    <v-row>
      <v-col cols="12">
        <v-select v-if="sessionsDates"
                  v-model="formData.showdate"
                  :items="sessionsDates"
                  placeholder="Date"
                  @update:modelValue="onSelectTrigger"
        />

        <v-select v-if="formData.showdate && sessionsTimes"
                  v-model="formData.daytime"
                  :items="sessionsTimes"
                  placeholder="Time"
                  @update:modelValue="onSelectTrigger"
        />

        <v-select v-if="formData.showdate && formData.daytime && placesRows"
                  v-model="formData.row"
                  :items="placesRows"
                  item-title="row"
                  item-value="row"
                  placeholder="Row"
        />

        <v-select v-if="formData.showdate && formData.daytime && formData.row && placesSeat"
                  v-model="formData.seat"
                  :items="placesSeat"
                  placeholder="Seat"
                  item-title="seat"
                  item-value="seat"
        />
      </v-col>
    </v-row>
  </v-card-text>

  <v-card-actions>
    <v-btn text="Cancel"
           variant="plain"
           @click="onCancelButtonClick"
    />

    <v-btn v-if="!v$.$invalid"
           color="primary"
           text="Submit"
           variant="tonal"
           :loading="loading"
           @click="onSubmitButtonClick"
    />
  </v-card-actions>
</template>
